///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
// 4th order in time
// 10th order in space
// no boundary condition
int XC2dWaveprop_1step4t10spaceoptinvvelin(float *dxinvvelinvdt2, float *wvt1, float *wvt2, float *wvt3, float *wvtmp, int izmin, int izmax, int ixmin, int ixmax)
{
  int fat,fat2,curidx;
  int ix,iz;
  int iz1,iz2;
  int ix1,ix2;
  fat=5;
  fat2=5;

  float temp1;
  
  int nx,nz;
  nx=XC2dWaveprop_nx;
  nz=XC2dWaveprop_nz;
  int nxtape,nztape;
  nxtape=XC2dWaveprop_nxtape;
  nztape=XC2dWaveprop_nztape;

  iz1=max((0+fat),(izmin));  iz2=min((nz-fat),(izmax));
  ix1=max((0+fat),(ixmin));  ix2=min((nx-fat),(ixmax));
  //iz1=0+fat;
  //iz2=nz-fat;

  //VerbMsg2("start 1 step propagation in Waveprop_op2, with izmin=%d, izmax=%d \n",iz1,iz2)
  float a5=1./3150.;
  float a4=-5./1008.;
  float a3=5./126.;
  float a2=-5./21.;
  float a1=5./3.;
  float a0=a1+a2+a3+a4+a5;

  
  float curv,scurv;
  float curval,outval;
  float tpwht=0.25f;

     //#pragma omp parallel for private(curidx,curval,temp1,outval,ix,iz,iy) schedule(dynamic,8)
  WpVerbMsg("start inner model calculation in 1step4t10spacewithbnd1optinvvelin in Waveprop_op2 \n")
  #pragma omp parallel for private(temp1,ix,iz) schedule(dynamic,8)
  for (ix=ix1;ix<ix2;ix++)
  {
        
     //#pragma omp parallel for private(curidx,curval,temp1,outval) schedule(dynamic,8)
     for (iz=iz1;iz<iz2;iz++)
     {
        temp1 = a5*(wvt2[ Wpzxloc(iz-5,ix) ] + wvt2[ Wpzxloc(iz+5,ix) ] + \
                    wvt2[ Wpzxloc(iz,ix-5) ] + wvt2[ Wpzxloc(iz,ix+5) ] ) ;
        temp1+= a4*(wvt2[ Wpzxloc(iz-4,ix) ] + wvt2[ Wpzxloc(iz+4,ix) ] + \
                    wvt2[ Wpzxloc(iz,ix-4) ] + wvt2[ Wpzxloc(iz,ix+4) ] ) ;
        temp1+= a3*(wvt2[ Wpzxloc(iz-3,ix) ] + wvt2[ Wpzxloc(iz+3,ix) ] + \
                    wvt2[ Wpzxloc(iz,ix-3) ] + wvt2[ Wpzxloc(iz,ix+3) ] ) ;
        temp1+= a2*(wvt2[ Wpzxloc(iz-2,ix) ] + wvt2[ Wpzxloc(iz+2,ix) ] + \
                    wvt2[ Wpzxloc(iz,ix-2) ] + wvt2[ Wpzxloc(iz,ix+2) ] ) ;
        temp1+= a1*(wvt2[ Wpzxloc(iz-1,ix) ] + wvt2[ Wpzxloc(iz+1,ix) ] + \
                    wvt2[ Wpzxloc(iz,ix-1) ] + wvt2[ Wpzxloc(iz,ix+1) ] ) ;
        temp1+= -4.0*a0*wvt2[Wpzxloc(iz,ix)];
        wvtmp[Wpzxloc(iz,ix)]  = temp1/dxinvvelinvdt2[Wpzxloc(iz,ix)];
          
     } 
  } 

  a2=-1./12.;
  a1=4./3.;
  a0=a1+a2;

  a0*=-4.0*a2;
  a1*=a2;
  a2*=a2;
  WpVerbMsg("start boundary calculation in 1step4t10spacewithbnd1optinvvelin in Waveprop_op2 \n")
  #pragma omp parallel for private(temp1,ix,iz) schedule(dynamic,8)
  for (ix=ix1;ix<ix2;ix++)
  {
     //#pragma omp parallel for private(izbegpad,izendpad,whtzbegpad,whtzendpad,curidx,curval,temp1,outval) schedule(dynamic,8)
     for (iz=iz1;iz<iz2;iz++)
     {
       temp1 = a2*(wvtmp[ Wpzxloc(iz-2,ix) ] + wvtmp[ Wpzxloc(iz+2,ix) ] );
       temp1+= a2*(wvtmp[ Wpzxloc(iz,ix-2) ] + wvtmp[ Wpzxloc(iz,ix+2) ] );
       temp1+= a1*(wvtmp[ Wpzxloc(iz-1,ix) ] + wvtmp[ Wpzxloc(iz+1,ix) ] );
       temp1+= a1*(wvtmp[ Wpzxloc(iz,ix-1) ] + wvtmp[ Wpzxloc(iz,ix+1) ] );
       temp1+= a0*wvtmp[Wpzxloc(iz,ix)];
       temp1/= dxinvvelinvdt2[Wpzxloc(iz,ix)];
       temp1= wvtmp[Wpzxloc(iz,ix)]-temp1;
       wvt3[Wpzxloc(iz,ix)] = 2.0*wvt2[Wpzxloc(iz,ix)]- wvt1[Wpzxloc(iz,ix)] + temp1;
     }
  }
  
  return 0; 
}
