///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
// 4th order in time
// 10th order in space
// with one-way boundary condition proposed by John Etgen
int XC2dWaveprop_1step4t10spacewithbnd1optinvvelin(float *dxinvvelinvdt2, float *wvt1, float *wvt2, float *wvt3, int izmin, int izmax, int ixmin, int ixmax)
{
  int fat,fat2,curidx;
  int ix,iz;
  int iz1,iz2;
  int ix1,ix2;
  fat=5;
  fat2=5;

  float temp1;
  
  int nx,nz;
  nx=XC2dWaveprop_nx;
  nz=XC2dWaveprop_nz;
  int nxtape,nztape;
  nxtape=XC2dWaveprop_nxtape;
  nztape=XC2dWaveprop_nztape;

  iz1=max((0+fat),(izmin));  iz2=min((nz-fat),(izmax));
  ix1=max((0+fat),(ixmin));  ix2=min((nx-fat),(ixmax));
  //iz1=0+fat;
  //iz2=nz-fat;

  //VerbMsg2("start 1 step propagation in Waveprop_op2, with izmin=%d, izmax=%d \n",iz1,iz2)
  float a5=1./3150.;
  float a4=-5./1008.;
  float a3=5./126.;
  float a2=-5./21.;
  float a1=5./3.;
  float a0=a1+a2+a3+a4+a5;

  
  float curv,scurv;
  float curval,outval;
  float tpwht=0.25f;
     //#pragma omp parallel for private(izbegpad,izendpad,whtzbegpad,whtzendpad,ixbegpad,ixendpad,whtxbegpad,whtxendpad,curidx,curval,temp1,outval) schedule(dynamic,8)

  //#pragma omp parallel for private(curidx,curval,temp1,outval,ix,iz) schedule(dynamic,8)
  WpVerbMsg("start inner model calculation in 1step4t10spacewithbnd1optinvvelin in Waveprop_op2 \n")
  #pragma omp parallel for private(temp1,ix,iz) schedule(dynamic,8)
  for (ix=ix1;ix<ix2;ix++)
  {
       
     //#pragma omp parallel for private(curidx,curval,temp1,outval) schedule(dynamic,8)
     for (iz=iz1;iz<iz2;iz++)
     {
        temp1 = a5*(wvt2[ Wpzxloc(iz-5,ix) ] + wvt2[ Wpzxloc(iz+5,ix) ] + \
                    wvt2[ Wpzxloc(iz,ix-5) ] + wvt2[ Wpzxloc(iz,ix+5) ] ) ;
        temp1+= a4*(wvt2[ Wpzxloc(iz-4,ix) ] + wvt2[ Wpzxloc(iz+4,ix) ] + \
                    wvt2[ Wpzxloc(iz,ix-4) ] + wvt2[ Wpzxloc(iz,ix+4) ] ) ;
        temp1+= a3*(wvt2[ Wpzxloc(iz-3,ix) ] + wvt2[ Wpzxloc(iz+3,ix) ] + \
                    wvt2[ Wpzxloc(iz,ix-3) ] + wvt2[ Wpzxloc(iz,ix+3) ] ) ;
        temp1+= a2*(wvt2[ Wpzxloc(iz-2,ix) ] + wvt2[ Wpzxloc(iz+2,ix) ] + \
                    wvt2[ Wpzxloc(iz,ix-2) ] + wvt2[ Wpzxloc(iz,ix+2) ] ) ;
        temp1+= a1*(wvt2[ Wpzxloc(iz-1,ix) ] + wvt2[ Wpzxloc(iz+1,ix) ] + \
                    wvt2[ Wpzxloc(iz,ix-1) ] + wvt2[ Wpzxloc(iz,ix+1) ] ) ;
        temp1+= -4.0*a0*wvt2[Wpzxloc(iz,ix)];
        wvt3[Wpzxloc(iz,ix)]  = temp1/dxinvvelinvdt2[Wpzxloc(iz,ix)];
          
     } 
  } 

  a2=-1./12.;
  a1=4./3.;
  a0=a1+a2;

  a0*=-4.0*a2;
  a1*=a2;
  a2*=a2;
  #pragma omp parallel for private(temp1,ix,iz) schedule(dynamic,8)
  for (ix=ix1;ix<ix2;ix++)
  {
     //#pragma omp parallel for private(izbegpad,izendpad,whtzbegpad,whtzendpad,curidx,curval,temp1,outval) schedule(dynamic,8)
     for (iz=iz1;iz<iz2;iz++)
     {
        temp1 = a2*(wvt3[ Wpzxloc(iz-2,ix) ] + wvt3[ Wpzxloc(iz+2,ix) ] );
        temp1+= a2*(wvt3[ Wpzxloc(iz,ix-2) ] + wvt3[ Wpzxloc(iz,ix+2) ] );
        temp1+= a1*(wvt3[ Wpzxloc(iz-1,ix) ] + wvt3[ Wpzxloc(iz+1,ix) ] );
        temp1+= a1*(wvt3[ Wpzxloc(iz,ix-1) ] + wvt3[ Wpzxloc(iz,ix+1) ] );
        temp1+= a0*wvt3[Wpzxloc(iz,ix)];
        temp1/= dxinvvelinvdt2[Wpzxloc(iz,ix)];
        temp1= wvt3[Wpzxloc(iz,ix)]-temp1;
        wvt1[Wpzxloc(iz,ix)] = 2.0*wvt2[Wpzxloc(iz,ix)]- wvt1[Wpzxloc(iz,ix)] + temp1;
     }
  }
  
  ////////////////////////////////////////////////////
  //boundary condition
  #pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
  //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
  for (ix=nxtape;ix<nx-nxtape;ix++)
  {
     //beg z boundary
        
     for (iz=nztape-1;iz>=0+fat+fat2;iz--)
     {
       curidx=Wpzxloc(iz,ix);
       outval=wvt1[ curidx ];
       curval=wvt2[ curidx ];
       curv=1./dxinvvelinvdt2[curidx];
       scurv=sqrtf(curv);
       //outval -= (tpwht*(nztape-iz))/nztape*(scurv*(outval-curval)+curv*(wvt2[Wpzxloc(iz-1,ix)]-curval));
       outval -= (tpwht*(nztape-iz))/nztape*(scurv*(outval-curval)+curv*(wvt2[curidx-1]-curval));
       wvt1[curidx] = outval;
     }
     for (iz=0+fat+fat2;iz>=0+fat;iz--)
     {
       curidx=Wpzxloc(iz,ix);
       curval=wvt2[ curidx ];
       curv=1./dxinvvelinvdt2[curidx];
       scurv=sqrtf(curv)*1.2;
       //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxloc(iz+1,ix)]))+wvt2[Wpzxloc(iz+1,ix)];
       outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx+1]))+wvt2[curidx+1];
       wvt1[curidx] = outval;
     }
     //end z boundary
     for (iz=nz-nztape;iz<nz-fat-fat2;iz++)
     {
       curidx=Wpzxloc(iz,ix);
       outval=wvt1[ curidx ];
       curval=wvt2[ curidx ];
       curv=1./dxinvvelinvdt2[curidx];
       scurv=sqrtf(curv);
       //outval -= tpwht*(0.+iz+nztape-nz)/nztape*(scurv*(outval-curval)+curv*(wvt2[Wpzxloc(iz+1,ix)]-curval));
       outval -= tpwht*(0.+iz+nztape-nz)/nztape*(scurv*(outval-curval)+curv*(wvt2[curidx+1]-curval));
       wvt1[curidx] = outval;
     }
     for (iz=nz-fat-fat2;iz<nz-fat;iz++)
     {
       curidx=Wpzxloc(iz,ix);
       curval=wvt2[ curidx ];
       curv=1./dxinvvelinvdt2[curidx];
       scurv=sqrtf(curv)*1.2;
       //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxloc(iz-1,ix)]))+wvt2[Wpzxloc(iz-1,ix)];
       outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx-1]))+wvt2[curidx-1];
       wvt1[curidx] = outval;
     }
  }

  //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
  //beg x boundary
  for (ix=nxtape-1;ix>0+fat+fat2;ix--)
  {
     for (iz=0+fat;iz<nz-fat;iz++)
     {
       curidx=Wpzxloc(iz,ix);
       outval=wvt1[ curidx ];
       curval=wvt2[ curidx ];
       curv=1./dxinvvelinvdt2[curidx];
       scurv=sqrtf(curv);
       //outval -= (tpwht*(nxtape-ix))/nxtape*(scurv*(outval-curval)+curv*(wvt2[Wpzxloc(iz,ix-1)]-curval));
       outval -= (tpwht*(nxtape-ix))/nxtape*(scurv*(outval-curval)+curv*(wvt2[curidx-nz]-curval));
       wvt1[curidx] = outval;
     }
  }
  //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
  for (ix=0+fat+fat2;ix>=0+fat;ix--)
  {
     for (iz=0+fat;iz<nz-fat;iz++)
     {
       curidx=Wpzxloc(iz,ix);
       curval=wvt2[ curidx ];
       curv=1./dxinvvelinvdt2[curidx];
       scurv=sqrtf(curv)*1.2;
       //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxloc(iz,ix+1)]))+wvt2[Wpzxloc(iz,ix+1)];
       outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx+nz]))+wvt2[curidx+nz];
       wvt1[curidx] = outval;
     }
  }
  //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
  //end x boundary
  for (ix=nx-nxtape;ix<nx-fat-fat2;ix++)
  {
     for (iz=0+fat;iz<nz-fat;iz++)
     {
       curidx=Wpzxloc(iz,ix);
       outval=wvt1[ curidx ];
       curval=wvt2[ curidx ];
       curv=1./dxinvvelinvdt2[curidx];
       scurv=sqrtf(curv);
       //outval -= tpwht*(0.+ix+nxtape-nx)/nxtape*(scurv*(outval-curval)+curv*(wvt2[Wpzxloc(iz,ix+1)]-curval));
       outval -= tpwht*(0.+ix+nxtape-nx)/nxtape*(scurv*(outval-curval)+curv*(wvt2[curidx+nz]-curval));
       wvt1[curidx] = outval;
     }
  }
  //#pragma omp parallel for private(curidx,curval,curv,scurv,outval,ix,iz) schedule(dynamic,8)
  for (ix=nx-fat-fat2;ix<nx-fat;ix++)
  {
     for (iz=0+fat;iz<nz-fat;iz++)
     {
       curidx=Wpzxloc(iz,ix);
       curval=wvt2[ curidx ];
       curv=1./dxinvvelinvdt2[curidx];
       scurv=sqrtf(curv)*1.2;
       //outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[Wpzxloc(iz,ix-1)]))+wvt2[Wpzxloc(iz,ix-1)];
       outval = 1./(1.+scurv)*((1.-scurv)*(curval-wvt1[curidx-nz]))+wvt2[curidx-nz];
       wvt1[curidx] = outval;
     }
  }

  return 0; 
}
